"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.extractStatements = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _antlr4Browser = _interopRequireDefault(require("@neo4j-cypher/antlr4-browser"));
var _editorSupport = require("@neo4j-cypher/editor-support");
var _antlr4Simple = require("@neo4j-cypher/antlr4-simple");
var _ReferencesListener = require("./ReferencesListener.simple");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
const extractStatements = input => {
  const referencesListener = new _ReferencesListener.ReferencesListener();
  const errorListener = new _editorSupport.ErrorListener();
  const chars = new _antlr4Browser.default.InputStream(input);
  const lexer = new _antlr4Simple.CypherLexer(chars);
  lexer.removeErrorListeners();
  lexer.addErrorListener(errorListener);
  const tokens = new _antlr4Browser.default.CommonTokenStream(lexer);
  const parser = new _antlr4Simple.CypherParser(tokens);
  parser.buildParseTrees = true;
  parser.removeErrorListeners();
  parser.addErrorListener(errorListener);
  parser.addParseListener(referencesListener);
  const parseTree = parser.cypher();
  const {
    queries,
    indexes
  } = referencesListener;
  const referencesProviders = _editorSupport.CypherTypes.SYMBOLIC_CONTEXTS.reduce((acc, t) => _objectSpread(_objectSpread({}, acc), {}, {
    [t]: new _editorSupport.ReferencesProvider(queries, indexes[t])
  }), {});
  return {
    parseTree,
    referencesListener,
    errorListener,
    referencesProviders
  };
};
exports.extractStatements = extractStatements;